#include <math.h>
#include <stdio.h>
#include <stdlib.h>


double interpola_tps1d_PO(double xc,double *x, double *f, int N);
// Phi + 0
double interpola_tps1d_P1(double xc,double *x, double *f, int N);
// Phi + 1 + x

double phitps2(double r, double c, int op)
{
double z;
  z= sqrt(r*r);

 if(fabs(r)<5e-7)
    return 0.0;
 else
    return z*z*log(z);
}

//-------------------------------------------------------------------
double interpola_tps1d_PO(double xc,double *x, double *f,  int N)
// Phi = r2logr
// Phi + 0
{
  double  **A;
  double  *lambda;
  int      i,j;

  A = make_dmatrix(N,N);
  lambda = make_dvector(N);

 for(i=0;i<N;i++)
  for(j=0;j<N;j++)
  {
     A[i][j] = 0;
  }
  

// Resuelvo
 double cond;
  int   flag;

   flag =    SolveLU(A,N,lambda,f,&cond);

if(flag!=0){
   printf("\n!ERROR: en el interpolante local, flag = %d con condi = %f\n",flag,cond);

   FILE *fid=fopen("logs.txt","a+");
   fprintf(fid,"Error: Ax=b regreso flag!=0,  condi=%f\n",cond);
   fprintf(fid,"  en '%s' , linea = %d\n",__FILE__,__LINE__);
   fclose(fid);

  exit(1);
}

// Interpolo
   double s;
   s=0.0;
   for(j=0;j<N;j++)
      s = s + lambda[j]*phitps2(xc-x[j],0,0);


  free_dmatrix(A,N);
  free_dvector(lambda);

  return s;
}


//-------------------------------------------------------------------
double interpola_tps1d_P1(double xc,double *x, double *f, int N)
// Phi + 1 + x
{
  double  **A,*ff;
  double  *lambda;
  double   cond;
  int      i,j;

  A = make_dmatrix(N+2,N+2);
  ff  = make_dvector(N+2);
  lambda = make_dvector(N+2);

 for(i=0;i<N+2;i++) ff[i]=0.0;

 for(i=0;i<N;i++)
 {
   ff[i] = f[i];
 }


 for(i=0;i<N+2;i++)
  for(j=0;j<N+2;j++)
  {
     A[i][j] = 0;
  }

// Agreo el polinimio
// [ Phi P ]
// [ P'  0 ]

 for(j=0;j<N;j++)
   A[j][N]=A[N][j]=1.0;

 for(j=0;j<N;j++)
   A[j][N+1]=A[N+1][j]=x[j];


for( i=0;i<N;i++)
  for( j=0;j<N;j++)
    A[i][j] = phitps2(x[i]-x[j],0,0);

// Resuelvo
    int flag;
    flag = SolveLU(A,N+2,lambda,ff,&cond);

if(flag!=0){
  printf("\n!ERROR: en el interpolante local, flag = %d con condi = %f\n",flag,cond);
  for(i=0;i<N;i++)
   printf("%f %f\n",x[i]);

   FILE *fid=fopen("logs.txt","a+");
   fprintf(fid,"Error: Ax=b regreso flag!=0,  condi=%f\n",cond);
   fprintf(fid,"  en '%s' , linea = %d\n",__FILE__,__LINE__);
   fclose(fid);


  exit(1);
}


// Interpolo
   double s;
   s=0.0;
   for( j=0;j<N;j++)
      s = s + lambda[j]*phitps2(xc-x[j],0,0);

  s=s+lambda[N];
  s=s+lambda[N+1]*xc;


  free_dmatrix(A,N+2);
  free_dvector(ff);
  free_dvector(lambda);

  return s;
}

