#include <math.h>
#include <stdio.h>
#include <stdlib.h>
//r4log2  requienre itera=20  con N=1927 para linf=4.7e-3 l2=1.2e-3
//r2logr  requienre itera=9  con N=2454  para linf=4.7e-3 l2=4.5e-3
double phitps4_2d(double r1,double r2)
{
 double z;
 z=sqrt(r1*r1+r2*r2);

 if(z==0)
   return 0;
 else
//   return (z*z*z*z)*log(z);
   return (z*z)*log(z);
}
//----------------------------------------------------------------
double interpola_tps2d_P1(double xc,double yc,double *x, double *y, double *f, int m)
  // Phi + 1 + x + y
{
  int i,j;	
  double  **A;
  double  *lambda;
  double  *ff;


  A      = make_dmatrix(m+3,m+3);
  lambda = make_dvector(m+3);
  ff     = make_dvector(m+3);

 for(i=0;i<m;i++)
   ff[i]=f[i];

   ff[m+0]=0.0;
   ff[m+1]=0.0;
   ff[m+2]=0.0;

 for(i=0;i<m+3;i++)
  for(j=0;j<m+3;j++)
  {
        A[i][j]=0;
  }

for(i=0;i<m;i++)
{
  A[i][m] = 1;  A[i][m+1]=x[i];  A[i][m+2]=y[i];
}
  
for(i=0;i<m;i++)
{
  A[m][i] = 1;  A[m+1][i]=x[i];  A[m+2][i]=y[i];
}


 for(i=0;i<m;i++)
  for(j=0;j<m;j++)
    A[i][j] = phitps4_2d(x[i]-x[j],y[i]-y[j]);



// Resuelvo
  double cond;
int   flag;
    flag=SolveLU(A,m+3,lambda,ff,&cond);

if(flag!=0){
  printf("\n!ERROR: en el interpolante local, flag = %d con condi = %f\n",flag,cond);
  for(i=0;i<m;i++)
   printf("%f %f\n",x[i],y[i]);

   FILE *fid=fopen("logs.txt","a+");
   fprintf(fid,"Error: Ax=b regreso flag!=0,  condi=%f\n",cond);
   fprintf(fid,"  en '%s' , linea = %d,  %s , time = %s\n\n",__FILE__,__LINE__,__DATE__,__TIME__);

     fprintf(fid,"X=[\n");
  for( i=0;i<m;i++)
     fprintf(fid,"%f %f %f\n",x[i],y[i],f[i]);

     fprintf(fid,"];\n");
     fprintf(fid,"plot(X(:,1),X(:,2),'b*');\n");
     fprintf(fid,"hold on;\n");
     fprintf(fid,"plot(%f,%f,'ro');\n",xc,yc);
     fprintf(fid,"hold off;\n");
        
   fclose(fid);
 //Actualizo el log de errores
  exit(1);
}

// Interpolo
   double s;
   s=0.0;
   for(j=0;j<m;j++)
      s = s + lambda[j]*phitps4_2d(xc-x[j],yc-y[j]);
      
 //Agrego el polinomio Phi + {1 + x + y}
   s  = s + lambda[m+0]; 
   s  = s + lambda[m+1]*xc;
   s  = s + lambda[m+2]*yc;


  free_dmatrix(A,m+3);
  free_dvector(lambda);
  free_dvector(ff);

  return s;
}
//----------------------------------------------------------------
double interpola_tps2d_P2(double xc,double yc,double *x, double *y, double *f, int m)
  // Phi + 1 + x + y + x*x + y*y +  x*y
{
  int     P=6;
  int     i,j;
  double  **A;
  double  *lambda;
  double  *ff;


  A      = make_dmatrix(m+P,m+P);
  lambda = make_dvector(m+P);
  ff     = make_dvector(m+P);

 for(i=0;i<m+P;i++)  ff[i]=0.0;
 for(i=0;i<m;i++)    ff[i]=f[i];

 for( i=0;i<m+P;i++)
  for( j=0;j<m+P;j++)
  {
     A[i][j]=0;
  }


for( i=0;i<m;i++)
{
  A[i][m]   = 1.0;
  A[i][m+1] = x[i];
  A[i][m+2] = y[i];
  A[i][m+3] = x[i]*x[i];
  A[i][m+4] = y[i]*y[i];
  A[i][m+5] = x[i]*y[i];

}

for( i=0;i<m;i++)
{
  A[m][i]  = 1.0;
  A[m+1][i]=x[i];
  A[m+2][i]=y[i];
  A[m+3][i]=x[i]*x[i];
  A[m+4][i]=y[i]*y[i];
  A[m+5][i]=x[i]*y[i];
}

 for( i=0;i<m;i++)
  for( j=0;j<m;j++)
    A[i][j] = phitps4_2d(x[i]-x[j],y[i]-y[j]);



// Resuelvo
  double cond;
int   flag;
    flag=SolveLU(A,m+P,lambda,ff,&cond);

if(flag!=0 | cond>1e20){

  free_dmatrix(A,m+P);
  free_dvector(lambda);
  free_dvector(ff);

  return 1e10;


 for( i=0;i<m;i++)
 {
  for( j=0;j<m;j++)
  {
    printf("%.3e ",A[i][j]);
  }
  printf("\n");
 }
  printf("\n");


  printf("\n!ERROR: en el interpolante local, flag = %d con condi = %e\n",flag,cond);
  for( i=0;i<m;i++)
   printf("%f %f\n",x[i],y[i]);

   FILE *fid=fopen("logs.txt","a+");
   fprintf(fid,"Error: Ax=b regreso flag!=0,  condi=%f\n",cond);
   fprintf(fid,"  en '%s' , linea = %d,  %s , time = %s\n\n",__FILE__,__LINE__,__DATE__,__TIME__);

     fprintf(fid,"X=[\n");
  for( i=0;i<m;i++)
     fprintf(fid,"%f %f %f\n",x[i],y[i],f[i]);

     fprintf(fid,"];\n");
     fprintf(fid,"plot(X(:,1),X(:,2),'b*');\n");
     fprintf(fid,"hold on;\n");
     fprintf(fid,"plot(%f,%f,'ro');\n",xc,yc);
     fprintf(fid,"hold off;\n");
   fclose(fid);

  exit(1);
}

// Interpolo
   double s;
   s=0.0;
   for(j=0;j<m;j++)
      s = s + lambda[j]*phitps4_2d(xc-x[j],yc-y[j]);

 //Agrego el polinomio Phi + {1 + x + y + x*x + y*y + x*y}
   s  = s + lambda[m];
   s  = s + lambda[m+1]*xc;
   s  = s + lambda[m+2]*yc;
   s  = s + lambda[m+3]*(xc*xc);
   s  = s + lambda[m+4]*(yc*yc);
   s  = s + lambda[m+5]*(xc*yc);


  free_dmatrix(A,m+P);
  free_dvector(lambda);
  free_dvector(ff);

  return s;
}


//----------------------------------------------------------------
double interpola_tps2d_P2a(double xc,double yc,double *x, double *y, double *f, int m)
  // Phi + 1 + x + y + x*x + y*y
{
  int     P=5;
  int     i,j;
  double  **A;
  double  *lambda;
  double  *ff;


  A      = make_dmatrix(m+P,m+P);
  lambda = make_dvector(m+P);
  ff     = make_dvector(m+P);

 for(i=0;i<m+P;i++)  ff[i]=0.0;
 for(i=0;i<m;i++)    ff[i]=f[i];

 for( i=0;i<m+P;i++)
  for( j=0;j<m+P;j++)
  {
     A[i][j]=0;
  }


for( i=0;i<m;i++)
{
  A[i][m]   = 1.0;
  A[i][m+1] = x[i];
  A[i][m+2] = y[i];
  A[i][m+3] = x[i]*x[i];
  A[i][m+4] = y[i]*y[i];
}

for( i=0;i<m;i++)
{
  A[m][i]  = 1.0;
  A[m+1][i]=x[i];
  A[m+2][i]=y[i];
  A[m+3][i]=x[i]*x[i];
  A[m+4][i]=y[i]*y[i];
}

 for( i=0;i<m;i++)
  for( j=0;j<m;j++)
    A[i][j] = phitps4_2d(x[i]-x[j],y[i]-y[j]);



// Resuelvo
  double cond;
int   flag;
    flag=SolveLU(A,m+P,lambda,ff,&cond);

if(flag!=0 | cond>1e20){

  free_dmatrix(A,m+P);
  free_dvector(lambda);
  free_dvector(ff);

  return 1e10;
 }

// Interpolo
   double s;
   s=0.0;
   for(j=0;j<m;j++)
      s = s + lambda[j]*phitps4_2d(xc-x[j],yc-y[j]);

 //Agrego el polinomio Phi + {1 + x + y + x*x + y*y }
   s  = s + lambda[m];
   s  = s + lambda[m+1]*xc;
   s  = s + lambda[m+2]*yc;
   s  = s + lambda[m+3]*(xc*xc);
   s  = s + lambda[m+4]*(yc*yc);



  free_dmatrix(A,m+P);
  free_dvector(lambda);
  free_dvector(ff);

  return s;
}


//----------------------------------------------------------------
double interpola_tps2d_P2b(double xc,double yc,double *x, double *y, double *f, int m)
  // Phi + 1 + x + y + x*x + y*y +  x*y + x*x*y + y*y*x
{
  int     P=8;
  int     i,j;
  double  **A;
  double  *lambda;
  double  *ff;


  A      = make_dmatrix(m+P,m+P);
  lambda = make_dvector(m+P);
  ff     = make_dvector(m+P);

 for(i=0;i<m+P;i++)  ff[i]=0.0;
 for(i=0;i<m;i++)    ff[i]=f[i];

 for( i=0;i<m+P;i++)
  for( j=0;j<m+P;j++)
  {
     A[i][j]=0;
  }


for( i=0;i<m;i++)
{
  A[i][m]   = 1.0;
  A[i][m+1] = x[i];
  A[i][m+2] = y[i];
  A[i][m+3] = x[i]*x[i];
  A[i][m+4] = y[i]*y[i];
  A[i][m+5] = x[i]*y[i];
  A[i][m+6] = x[i]*x[i]*y[i];
  A[i][m+7] = y[i]*y[i]*x[i];
}

for( i=0;i<m;i++)
{
  A[m][i]  = 1.0;
  A[m+1][i]=x[i];
  A[m+2][i]=y[i];
  A[m+3][i]=x[i]*x[i];
  A[m+4][i]=y[i]*y[i];
  A[m+5][i]=x[i]*y[i];
  A[m+6][i] = x[i]*x[i]*y[i];
  A[m+7][i] = y[i]*y[i]*x[i];
}

 for( i=0;i<m;i++)
  for( j=0;j<m;j++)
    A[i][j] = phitps4_2d(x[i]-x[j],y[i]-y[j]);



// Resuelvo
  double cond;
int   flag;
    flag=SolveLU(A,m+P,lambda,ff,&cond);

if(flag!=0 | cond>1e20){

  free_dmatrix(A,m+P);
  free_dvector(lambda);
  free_dvector(ff);

  return 1e10;
}

// Interpolo
   double s;
   s=0.0;
   for(j=0;j<m;j++)
      s = s + lambda[j]*phitps4_2d(xc-x[j],yc-y[j]);

 //Agrego el polinomio Phi + {1 + x + y + x*x + y*y + x*y + x*x*y + y*y*x}
   s  = s + lambda[m];
   s  = s + lambda[m+1]*xc;
   s  = s + lambda[m+2]*yc;
   s  = s + lambda[m+3]*(xc*xc);
   s  = s + lambda[m+4]*(yc*yc);
   s  = s + lambda[m+5]*(xc*yc);
   s  = s + lambda[m+6]*(xc*xc*yc);
   s  = s + lambda[m+7]*(xc*yc*yc);


  free_dmatrix(A,m+P);
  free_dvector(lambda);
  free_dvector(ff);

  return s;
}


//----------------------------------------------------------------
