int tipo_funcion;             // 0  = Poisson,  1== Conveccion Difusion
double (*fnc_ptr)(double,double,double,int);      // MQ o TPS

//-------------------------------------------------------------------
void   save_data_iter(double **x,double **y,double **z, int N, int iteracion)
{
 int     i;
 double  xc,yc,sol;
 char    filename[256];
 FILE    *out;

  sprintf(filename,"%s/history/numericar%d.m",cfg.path,iteracion);
  out = fopen(filename,"w+");

  if(out==NULL){
   //Actualizo el log de errores
     FILE *fid=fopen("logs.txt","a+");
     fprintf(fid,"-----------------------------------------------------------------------\n");
     fprintf(fid,"ERROR: el archivo '%s' no se logro crear.\n\n",filename);
     fprintf(fid,"en '%s' , linea = %d,  %s , %s\n\n",__FILE__,__LINE__,__DATE__,__TIME__);
     fclose(fid);
     exit(1);
  }
 int j;

  fprintf(out,"x=[;\n");
 for(i=0;i<N;i++)
 {
  for(j=0;j<N;j++)
  {
    fprintf(out,"%f ",x[i][j]);
  }
  fprintf(out,"\n");
 }
 fprintf(out,"];\n");

  fprintf(out,"y=[;\n");
 for(i=0;i<N;i++)
 {
  for(j=0;j<N;j++)
  {
    fprintf(out,"%f ",y[i][j]);
  }
  fprintf(out,"\n");
 }
 fprintf(out,"];\n");


  fprintf(out,"z=[;\n");
 for(i=0;i<N;i++)
 {
  for(j=0;j<N;j++)
  {
    fprintf(out,"%f ",z[i][j]);
  }
  fprintf(out,"\n");
 }
 fprintf(out,"];\n");




 fclose(out);
}

//figure,numericar1,surfl(x,y,z),shading interp,colormap gray

//----------------------------------------------------------------------------------------------------
void  interpola_sol(double *x, double *y,double *my_c,double *lambda,double m,double *X, double *Y, double *sol_refinada, int N)
{
double s;
 for(int i=0;i<N;i++)
 {
  s=0.0;
   for(int j=0;j<m;j++)
   {
      s += lambda[j]*fnc_ptr(X[i]-x[j],Y[i]-y[j],my_c[j],0);
   }
     sol_refinada[i] = s;
 }
}
//----------------------------------------------------------------------------------------------------
void  interpola_sol_uxx(double *x, double *y,double *my_c,double *lambda,double m,double *X, double *Y, double *sol_refinada, int N)
{
double s;
 for(int i=0;i<N;i++)
 {
  s=0.0;
   for(int j=0;j<m;j++)
   {
      s += lambda[j]*fnc_ptr(X[i]-x[j],Y[i]-y[j],my_c[j],5);
   }
     sol_refinada[i] = s;
 }
}
//----------------------------------------------------------------------------------------------------
double  calc_error(double *x, double *y, double *lambda, double *sol_numerica, double *sol_real, int ni, int m, double *my_c)
{
 double error,s;
// double *sol_real;
 double mu=1;


// sol_real  = make_dvector(m);


//Para los nodos interiores
 for(int i=0;i<ni;i++)
 {
  s=0.0;
   for(int j=0;j<m;j++)
   {
      s += lambda[j]*fnc_ptr(x[i]-x[j],y[i]-y[j],my_c[j],0);
   }
     sol_numerica[i] = s;
     //sol_real[i]     = u(x[i],y[i],mu);

   }

//Para los nodos frontera
 for(int i=ni;i<m;i++)
 {
  s=0.0;
   for(int j=0;j<m;j++)
   {
     s += lambda[j]*fnc_ptr(x[i]-x[j],y[i]-y[j],my_c[j],0);
   }
     sol_numerica[i] = s;
     //sol_real[i]     = u(x[i],y[i],mu);
   }

  error = calc_rms(sol_numerica,sol_real,m);


//  free_dvector(sol_real);

  return error;
}

//----------------------------------------------------------------------------------------------------------------

int resuelve_ddmMQC(int iteracion,int Party,TIPO_EDP tipo_edp,tree **data, int N, IPs    dominios[MAX_SUBDOMAINS])
{
//Las variables estatica
 FILE *out;
 int    i,j;
 char   filename[128];
 double gerror,gsuma_error;
 int    myRank;
 double error_paro;
 int    max_iters;
 double Convectivo,Difusivo;
 double mu=1.0;
 double  cond[MAX_SUBDOMAINS];
 int     m[MAX_SUBDOMAINS],ni[MAX_SUBDOMAINS],nf[MAX_SUBDOMAINS];

//Las variables dinamica
  double *x[MAX_SUBDOMAINS],*y[MAX_SUBDOMAINS],*ind[MAX_SUBDOMAINS];
  int    *ips[MAX_SUBDOMAINS];
  double *C[MAX_SUBDOMAINS];
  double **A[MAX_SUBDOMAINS];
  int    *pivot_index[MAX_SUBDOMAINS];
  double *lambda[MAX_SUBDOMAINS];
  double *fx[MAX_SUBDOMAINS];
  double *sol_numerica[MAX_SUBDOMAINS];
  double *sol_real[MAX_SUBDOMAINS];



 fnc_ptr  = phimq2;



 max_iters   = 300;
 error_paro  = 0.001;

//Determino el tipo de funcion a resolver
 if(tipo_edp==CONVECCION_DIFUSION){
      tipo_funcion=CONVECCION_DIFUSION;
      Convectivo = 1000.0;
      Difusivo   = 1.0;
      printf("tipo  EDP =  Conveccion - Difusion\n");
      printf("Convectivo  = %f\n",Convectivo);
      printf("Difusivo    = %f\n",Difusivo);
  }
 else{
      tipo_funcion=POISSON;
      printf("tipo  EDP =  Poisson\n");
 }


//Asigno el tamanio de cada subdominio
 for(int myRank=0;myRank<Party;myRank++)
 {
    m[myRank]   = dominios[myRank].n;
 }

//Cuento cuanta memoria voy a utilizar
double suma=0;
for(myRank=0; myRank<Party; myRank++)
{
  suma = suma  + sizeof(double)*(m[myRank]*4); //x,y,ind,C
  suma = suma  + sizeof(double)*(m[myRank]*4); //lambda,fx,sol_numerica,sol_real
  suma = suma  + sizeof(int)*(m[myRank]*2);    //pivot_index, ips
  suma = suma  + sizeof(double)*(m[myRank]*m[myRank]); //A
}
 printf("Requiero de memoria = %f  Megas \n",suma/1000000.0);





//Creo la memoria dinamica
 for(int myRank=0;myRank<Party;myRank++)
 {
  x[myRank]    = make_dvector(m[myRank]);
  y[myRank]    = make_dvector(m[myRank]);
  ind[myRank]  = make_dvector(m[myRank]);
   C[myRank]   = make_dvector(m[myRank]);
 ips[myRank]   = make_ivector(m[myRank]);

 sol_real[myRank] = make_dvector(m[myRank]);
 }


//Cargo/Asigno cada subdominio a memoria: ya estan ordenados con respecto
//del tipo de nodo
  double xc,yc;
  double myc;
  int    ip;
  TIPO_NODO tipo_nodo;
 for(int myRank=0;myRank<Party;myRank++)
 {
   for(int i=0;i<m[myRank];i++)
   {
     ip        = dominios[myRank].ips[i];
     xc        = data[ip]->x;
     yc        = data[ip]->y;
     myc       = data[ip]->c;
     tipo_nodo = dominios[myRank].tipo_nodo[i];

     x[myRank][i]   = xc;
     y[myRank][i]   = yc;
     C[myRank][i]   = myc;
     ind[myRank][i] = tipo_nodo;
     ips[myRank][i] = (int)ip;
   }

  //Veo que no esten repetidos
   for(int i=0;i<m[myRank];i++)
     for(int j=i+1;j<m[myRank];j++)
      if(x[myRank][i]==x[myRank][j] & y[myRank][i]==y[myRank][j])
        printf("repetidos [%d](%f,%f) == [%d](%f,%f)\n",i+1,x[myRank][i],y[myRank][i],j+1,x[myRank][j],y[myRank][j]);
           
 }


//Cuento el numero de nodos en cada subdominio
//Cargo todos los nodos ... jeje
for(myRank=0; myRank<Party; myRank++)
{
int cont_interior=0;
int cont_actualiza=0;
int cont_real=0;
int cont_artificial=0;


   for(int i=0;i<m[myRank];i++)
   {
     if(ind[myRank][i]==INTERIOR)             cont_interior++;
     //if(ind[myRank][i]==NODO_ACTUALIZA)       cont_actualiza++;
     if(ind[myRank][i]==FRONTERA_REAL)        cont_real++;
    // if(ind[myRank][i]==ESQUINA)              cont_real++;
     if(ind[myRank][i]==FRONTERA_ARTIFICIAL)  cont_artificial++;
   }


   printf("Proceso : %d, interior=%d,  artificial=%d, frontera_real=%d\n",
           myRank,cont_interior,
           cont_artificial,cont_real);

//defino de nuevo el tipo de nodos
   ni[myRank] = cont_interior;
   nf[myRank] = cont_real + cont_artificial;
}


//Contruyo las matrices para hacer Uxx+Uyy=f(x,y)
 double ux,uy,uxx_yy;
   for(myRank=0; myRank<Party; myRank++)
{
  A[myRank]            = make_dmatrix(m[myRank],m[myRank]);
  lambda[myRank]       = make_dvector(m[myRank]);
  fx[myRank]           = make_dvector(m[myRank]);
  sol_numerica[myRank] = make_dvector(m[myRank]);
  pivot_index[myRank]  = make_ivector(m[myRank]);
}

for(myRank=0; myRank<Party; myRank++)
{
  for(i=0;i<ni[myRank];i++)
  {
    for( j=0;j<m[myRank];j++)
    {
      if(tipo_funcion==POISSON)
      {
         uxx_yy =fnc_ptr(x[myRank][i]-x[myRank][j],y[myRank][i]-y[myRank][j],C[myRank][j],5);
         A[myRank][i][j]=  uxx_yy;
      }
      if(tipo_funcion==CONVECCION_DIFUSION)
      {
        uxx_yy =fnc_ptr(x[myRank][i]-x[myRank][j],y[myRank][i]-y[myRank][j],C[myRank][j],5);
        ux=fnc_ptr(x[myRank][i]-x[myRank][j],y[myRank][i]-y[myRank][j],C[myRank][j],1); //ux
        uy=fnc_ptr(x[myRank][i]-x[myRank][j],y[myRank][i]-y[myRank][j],C[myRank][j],3); //uy

        A[myRank][i][j]=  Difusivo*uxx_yy + Convectivo*ux + Convectivo*uy;
      }
    }
     fx[myRank][i]=uxx(x[myRank][i],y[myRank][i],mu); // nodo interior
   }

  for( i=ni[myRank];i<m[myRank];i++)
  {
    for( j=0;j<m[myRank];j++)
    {
      A[myRank][i][j]=fnc_ptr(x[myRank][i]-x[myRank][j],y[myRank][i]-y[myRank][j],C[myRank][j],0);
    }
     fx[myRank][i]=u(x[myRank][i],y[myRank][i],mu);  // nodo frontera
   }
   Factor(A[myRank],m[myRank],&cond[myRank],pivot_index[myRank]);
   
   if((myRank%2)==0)
     printf("[%d] cond=%e ",myRank,cond[myRank]);
   else printf("[%d] cond=%e \n",myRank,cond[myRank]);
}
 printf("\n");


for(myRank=0; myRank<Party; myRank++)
{
  for(i=0;i<m[myRank];i++)
  {
    sol_real[myRank][i] = u(x[myRank][i],y[myRank][i],mu) ;
  }
}




// Asigno a 0 los nodos que no son frontera_artificial
// Salvo a disco dichos nodos
for(myRank=0; myRank<Party; myRank++)
{
  double val_ini=0.0;
  for( i=0;i<m[myRank];i++)
  {
    if(ind[myRank][i]==FRONTERA_ARTIFICIAL) fx[myRank][i]= val_ini;
  }
}


 int        paro=0;
 double error[MAX_SUBDOMAINS];
 double e_inf[MAX_SUBDOMAINS];
 double s_dif;
 double s_dif_old;
 int    ip_xc;

 s_dif_old=0;


 paro=0;
 s_dif_old=0;


int  cont_info=0;
int  info[50000][4];

for(int iter=0; iter<max_iters & (paro==0); iter++)
{
 s_dif=0;
   //Limpio los buffers de los errores
      for(myRank=0; myRank<Party; myRank++) error[myRank]=e_inf[myRank]=0;

 //Barro todos los dominios
   for(myRank=0; myRank<Party; myRank++)
  {
         //Resuelvo el sistema
           copy(fx[myRank],m[myRank],lambda[myRank]);
           Solve(A[myRank],m[myRank],pivot_index[myRank],lambda[myRank]); // out --> fx=lambda

       //Calculo el error y a la vez obtengo la soluci\'on u(x,y)
 error[myRank]=calc_error(x[myRank],y[myRank],lambda[myRank],sol_numerica[myRank],sol_real[myRank],ni[myRank],m[myRank],C[myRank]);
 e_inf[myRank]=calc_einf(sol_numerica[myRank],sol_real[myRank],m[myRank]);

       if(error[myRank]>1000){
                  iter=max_iters;
                  exit(1);
                   break;
           }
 
     // Comienza el intercambio de informacion entre particiones vecinas
     //Actualizo los datos de frontera artificial aumentada
         int    band;
         int    ip_der;
	 int    ip_izq;
         double val;
         //double xc,yc;
         double indi,soli;
         int  conti;
          conti=0;

 if(iter==0)
{
        for(int i=0;i<m[myRank];i++)
        {
        // if(ind[myRank][i]==NODO_ACTUALIZA)
	 {
           val = sol_numerica[myRank][i];
          // xc  = x[myRank][i];
          // yc  = y[myRank][i];
         ip_xc = ips[myRank][i];

           for(ip_der=0; ip_der<Party;ip_der++)
	   {
 	    if(ip_der!=myRank)
            {
	      //Busco en el nodo vecino aquel nodo que sea (xy,yc)
	        for(int j=0;j<m[ip_der];j++)
                {
 	          if(ind[ip_der][j]==FRONTERA_ARTIFICIAL)
                  {
                     //if(ind[myRank][i]==FRONTERA_ARTIFICIAL)
                     //  printf("!WARNING: se esta actualizando FA ==> FA;  %d %d\n",myRank,ip_der);
 		  //if( (fabs(xc-x[ip_der][j])<0.5e-7) & (fabs(yc-y[ip_der][j])<0.5e-7))
                   if(ip_xc == ips[ip_der][j])
                   {
                   // printf("%d %d\n",(int)ips[myRank][i],(int)ips[ip_der][j]);
	            s_dif=s_dif+fabs(fx[ip_der][j]-val);
                    fx[ip_der][j]=val;
                    conti++;
                  // almaceno la informacion.....jeje
                       info[cont_info][0] = myRank;  // subdominio  actual que es que va a enviar la informacion
                       info[cont_info][1] = i; // el indice : sol[myRank][i];
                       info[cont_info][2] = ip_der;
                       info[cont_info][3] = j;  // fx[ip_der][j] = sol[myRank][i];
                       cont_info++;
                   }
                  }//if
               }//for
	      }//if
	   } //for(int i=0;i<m[myRank];i++)
	 }
       }
      printf("cont_info = %d\n",cont_info);
 } // iter==0


if(iter>0)
{

   for(int i=0;i<cont_info;i++)
   {
         if(info[i][0]==myRank)
         {
	    s_dif=s_dif + fabs(fx[info[i][2]][info[i][3]]-sol_numerica[myRank][info[i][1]]);
            fx[info[i][2]][info[i][3]] = sol_numerica[myRank][info[i][1]];
         }
   }
}


}  // myRank

  double rms=0;
   for(int i=0; i<Party; i++)	rms = rms + error[i];

   double error_inf;
   maximo(e_inf,myRank,&error_inf);


  double diff_suma;

  if(iter==0)  diff_suma=s_dif;
  else  diff_suma=fabs(s_dif_old-s_dif);

  s_dif_old=s_dif;


    printf("Iter=%d  rms=%f e_inf=%f  diff_s_dif=%f  with diff=%f\n",iter,rms/double(Party),error_inf,diff_suma,s_dif);

 //Pregunto si ya converge el error residual o el error de las fronteras artificiales
   double mem_sdif,mem_residuo;
  if(diff_suma<error_paro)       paro=1;
 

   cfg.e_rms = rms/double(Party);
   cfg.e_inf = error_inf;

}//for(int iter=0; iter<2500; iter++)


// Muestro el error residual
for(myRank=0; myRank<Party; myRank++)
{
  printf("[%d] rms = %.7f  e_inf = %f\n",myRank,error[myRank],e_inf[myRank]);
}
//Salvo el error de cada subdominio
  sprintf(filename,"%s/errores.txt",cfg.path);

  if(iteracion==0)
     out = fopen(filename,"w+");
  else
     out = fopen(filename,"a+");

  if(out!=NULL){
  fprintf(out,"Iteracion = %d, con e_rms = %f , e_inf = %f\n",iteracion,cfg.e_rms,cfg.e_inf);

 for(myRank=0; myRank<Party; myRank++)
  fprintf(out,"[%d] rms = %.7f  e_inf = %f\n",myRank,error[myRank],e_inf[myRank]);

 fclose(out);
 }

//-----------------------------------------------------------------------------------------------------

//Asigno la solucion obtenida
//Regreso los datos a como estaban, pero con el tipo_nodo actualizado
 for(int myRank=0;myRank<Party;myRank++)
 {
   for(int i=0;i<m[myRank];i++)
   {
     ip            = dominios[myRank].ips[i];
    if(dominios[myRank].tipo_nodo[i]!=FRONTERA_ARTIFICIAL)
     data[ip]->sol = sol_numerica[myRank][i];
   }
 }

//Determino el error al estilo de MultiGrid...jejej
  tree  *nodo;
  double *X, *Y, *sol_refinada;
  double s,tmp,maxi,mini;
  int    cont;
  double max_error=0;

   X = make_dvector(4);
   Y = make_dvector(4);
   sol_refinada = make_dvector(4);
     
/*
 for(int myRank=0;myRank<Party;myRank++)
 {

   for(int i=0;i<m[myRank];i++)
   {
     ip        = dominios[myRank].ips[i];
     nodo      = data[ip];
     refina_nodo(nodo,&X[0],&Y[0]);

      interpola_sol(x[myRank],y[myRank],C[myRank],lambda[myRank],m[myRank],X,Y,sol_refinada,4);

      sol_refinada[0] = fabs(nodo->sol -sol_refinada[0])/fabs(nodo->sol);
      sol_refinada[1] = fabs(nodo->sol -sol_refinada[1])/fabs(nodo->sol);;
      sol_refinada[2] = fabs(nodo->sol -sol_refinada[2])/fabs(nodo->sol);;
      sol_refinada[3] = fabs(nodo->sol -sol_refinada[3])/fabs(nodo->sol);;

      maximo(sol_refinada,4,&maxi);
      minimo(sol_refinada,4,&mini);

      nodo->error = (sol_refinada[0]+sol_refinada[1]+sol_refinada[2]+sol_refinada[3])/4.0;


      if(nodo->x==0 & nodo->y==1) // es una esquina
      {
        X[0] = nodo->xmin + 0.5*(nodo->xmax-nodo->xmin);
        Y[0] = nodo->ymax;

        X[1] = nodo->xmin;
        Y[1] = nodo->ymin + 0.5*(nodo->ymax-nodo->ymin);

        interpola_sol(x[myRank],y[myRank],C[myRank],lambda[myRank],m[myRank],X,Y,sol_refinada,2);

       sol_refinada[0] = fabs(nodo->sol -sol_refinada[0])/fabs(nodo->sol);;
       sol_refinada[1] = fabs(nodo->sol -sol_refinada[1])/fabs(nodo->sol);;

       nodo->error = (sol_refinada[0]+sol_refinada[1])/2.0;
      }
      else if(nodo->x==0 & nodo->y==0) // es una esquina
      {
        refina_nodo_esquina(nodo,&X[0],&Y[0]);
        interpola_sol(x[myRank],y[myRank],C[myRank],lambda[myRank],m[myRank],X,Y,sol_refinada,2);

       sol_refinada[0] = fabs(nodo->sol -sol_refinada[0])/fabs(nodo->sol);;
       sol_refinada[1] = fabs(nodo->sol -sol_refinada[1])/fabs(nodo->sol);;

       nodo->error = (sol_refinada[0]+sol_refinada[1])/2.0;
      }
     else if(nodo->x==0) // es un borde
     {
        X[0] = nodo->xmin;
        Y[0] = nodo->ymin + 0.25*(nodo->ymax-nodo->ymin);


        X[1] = nodo->xmin;
        Y[1] = nodo->ymin + 0.75*(nodo->ymax-nodo->ymin);

        interpola_sol(x[myRank],y[myRank],C[myRank],lambda[myRank],m[myRank],X,Y,sol_refinada,2);

       sol_refinada[0] = fabs(nodo->sol -sol_refinada[0])/fabs(nodo->sol);;
       sol_refinada[1] = fabs(nodo->sol -sol_refinada[1])/fabs(nodo->sol);;

       nodo->error = (sol_refinada[0]+sol_refinada[1])/2.0;
     }
     else if(nodo->y==0) // es un borde
     {
        X[0] = nodo->xmin + 0.25*(nodo->xmax-nodo->xmin);
        Y[0] = nodo->ymin;

        X[0] = nodo->xmin + 0.75*(nodo->xmax-nodo->xmin);
        Y[0] = nodo->ymin;


        interpola_sol(x[myRank],y[myRank],C[myRank],lambda[myRank],m[myRank],X,Y,sol_refinada,2);

       sol_refinada[0] = fabs(nodo->sol -sol_refinada[0])/fabs(nodo->sol);;
       sol_refinada[1] = fabs(nodo->sol -sol_refinada[1])/fabs(nodo->sol);;

       nodo->error = (sol_refinada[0]+sol_refinada[1])/2.0;
     }
   }
 }

 */
 /*
 for(int myRank=0;myRank<Party;myRank++)
 {
   for(int i=0;i<m[myRank];i++)
   {
     ip        = dominios[myRank].ips[i];
     nodo      = data[ip];

       double thetar,thetac;
       thetar = 0.01;
       thetac = 0.001;

      nodo->refina = 0;

     if(nodo->error>thetar)
     {
        nodo->refina = 1;
     }
     else    if(nodo->error<thetac)
     {
       nodo->refina = -1;
     }

   }
}

 */


//Interpolo en un grid mas fino...jejej
 for(int myRank=0;myRank<Party;myRank++)
 {
   X = make_dvector(ni[myRank]*4);
   Y = make_dvector(ni[myRank]*4);
sol_refinada = make_dvector(ni[myRank]*4);
   cont=0;
   for(int i=0;i<ni[myRank];i++)
   {
     ip        = dominios[myRank].ips[i];
     nodo      = data[ip];
     refina_nodo(nodo,&X[cont],&Y[cont]);
     cont+=4;
   }
   interpola_sol(x[myRank],y[myRank],C[myRank],lambda[myRank],m[myRank],X,Y,sol_refinada,cont);

//Calculo el e_rms y el e_inf
    s=0;
    maxi=0;
   for(int i=0;i<cont;i++)
   {
     tmp =  fabs(sol_refinada[i] - u(X[i],Y[i],mu));
     s = s + tmp*tmp;
     if(tmp>maxi) maxi=tmp;
   }

  error[myRank]= sqrt(s/double(cont));
  e_inf[myRank]= maxi;

  free_dvector(X);
  free_dvector(Y);
  free_dvector(sol_refinada);
 }

//Muestro el error obtenido
   printf("\nErrores en un grid + fino de nodos interiores x subdominio son:\n");
for(myRank=0; myRank<Party; myRank++)
{
  printf("[%d] rms = %.7f  e_inf = %f\n",myRank,error[myRank],e_inf[myRank]);
}
printf("\n");
double rms;
   rms=0;
    maximo(e_inf,myRank,&maxi);
   for(int i=0; i<Party; i++)	rms = rms + error[i];

 printf("e_rms_promedio = %f      e_inf_all = %f\n",rms/double(Party),maxi);

printf("\n");



//Salvo las soluciones de todos los subdominios para plotearlas
// Los salvo para plotear con GNU-Plot: load show
// Los salvo para plotear con GNU-Plot: solucion.m
  save_all_sol(Party,data,N,dominios);

// Los salvo para plotear con GNU-Plot: load showdiff
// Los salvo para plotear con Matlab:   realnum
   save_all_diff(Party,data,N,dominios);






//***********************
 double xmin,xmax,ymin,ymax;
 double aux[100];
 double **X2,**Y2,**Z2;
 double min;
 double h,M2;
 int    ip_min;

  M2   = 50;
  h    = 0.5/double(M2-1);

  X2   = make_dmatrix(M2,M2);
  Y2   = make_dmatrix(M2,M2);
  Z2   = make_dmatrix(M2,M2);

  xmin =  0.0;  xmax = 0.5;
  ymin =  0.0;  ymax = 0.5;


  for(int i=0;i<M2;i++)
   for(int j=0;j<M2;j++)
   {
     X2[i][j] = xmin + h*i;
     Y2[i][j] = ymin + h*j;
     Z2[i][j] = 0.0;
   }

for(int i=0;i<M2;i++)
 for(int j=0;j<M2;j++)
 {
    xc  = X2[i][j];
    yc  = Y2[i][j];
    min = 1e12;
    ip_min = 0;
    for(int myRank=0;myRank<Party;myRank++)
    {
     s=0;
      for(int k=0;k<m[myRank];k++)
      {
        s += lambda[myRank][k]*phimq2(xc-x[myRank][k],yc-y[myRank][k],C[myRank][k],0);
      }

    aux[myRank] = s;
    }

    for(int myRank=0;myRank<Party;myRank++)
    {
      if(fabs(aux[myRank]-u(xc,yc,mu))<min)
      {
       min=fabs(s-u(xc,yc,mu));
       ip_min = myRank;
      }
    }

    Z2[i][j]= aux[ip_min];
  }


  save_data_iter(X2,Y2,Z2,M2,iteracion);

  free_dmatrix(X2,M2);
  free_dmatrix(Y2,M2);
  free_dmatrix(Z2,M2);

//***********************




//Libero la memoria dinamica reservada
for(myRank=0; myRank<Party; myRank++)
{
 free_dvector(x[myRank]);
 free_dvector(y[myRank]);
 free_dvector(ind[myRank]);
 free_dvector(C[myRank]);
 free_dmatrix(A[myRank],m[myRank]);
 free_ivector(pivot_index[myRank]);
 free_dvector(lambda[myRank]);
 free_dvector(fx[myRank]);
 free_dvector(sol_numerica[myRank]);
 free_dvector(sol_real[myRank]);
 free_ivector(ips[myRank]);
}
 return 0;
}


