

void  save_sol(double *x, double *y, double *sol, int N, double mu);
void  save_nodos(double *x,double *y, int Ni, int N);
void  save_error_local(double *x, double *y, double *error, int N);

void  save_nodos(tree *raiz)
{
   int N,Ni;

   double *x,*y;

   N=0; cont_hojas(raiz,N);

   x = new double[N];
   y = new double[N];
   
//Vuelvo a obtener los datos
   Ni=0;  get_datos_interior(raiz,x,y,Ni);
   N=Ni;  get_datos_frontera(raiz,x,y,N);

// Salvo los nodos para mostrarlos : data.m, data
   save_nodos(x,y,Ni,N);

  delete[] x;
  delete[] y;
}



//-------------------------------------------------------------------
void  save_error_local(double *x, double *y, double *error, int N)
{
  int   i;
  char filename[256];
  FILE *out;

//Guardo en formato Matlab
  sprintf(filename,"%s/errorlocal.m",cfg.path);
  out = fopen(filename,"w+");

  if(out==NULL){
   //Actualizo el log de errores
     FILE *fid=fopen("logs.txt","a+");
     fprintf(fid,"-----------------------------------------------------------------------\n");
     fprintf(fid,"ERROR: el archivo '%s' no se logro abrir.\n\n",filename);
     fprintf(fid,"en '%s' , linea = %d,  %s , %s\n\n",__FILE__,__LINE__,__DATE__,__TIME__);
     fclose(fid);
     return;
  }


   fprintf(out,"X=[\n");
   for(i=0;i<N;i++)
     fprintf(out,"%f %f %f\n",x[i],y[i],error[i]);
  fprintf(out,"];\n");
  fprintf(out,"x=X(:,1);\n");
  fprintf(out,"y=X(:,2);\n");
  fprintf(out,"z=X(:,3);\n");
  fprintf(out,"plot3(x,y,z,'.');\n");
  fclose(out);

//Guardo en formato GNU-plot
   sprintf(filename,"%s/errorlocal",cfg.path);
   out = fopen(filename,"w+");

  if(out==NULL){
   //Actualizo el log de errores
     FILE *fid=fopen("logs.txt","a+");
     fprintf(fid,"-----------------------------------------------------------------------\n");
     fprintf(fid,"ERROR: el archivo '%s' no se logro abrir.\n\n",filename);
     fprintf(fid,"en '%s' , linea = %d,  %s , %s\n\n",__FILE__,__LINE__,__DATE__,__TIME__);
     fclose(fid);
     return;
  }

   for(i=0;i<N;i++)
     fprintf(out,"%f %f %f\n",x[i],y[i],error[i]);
  fclose(out);
}
//-------------------------------------------------------------------
void save_nodos(double *x,double *y, int Ni, int N)
{
   int  i;
   char  filename[256];
   FILE *out;
//Guardo en formato Matlab los nodos interiores
  sprintf(filename,"%s/data.m",cfg.path);
  out = fopen(filename,"w+");

  if(out==NULL){
   //Actualizo el log de errores
     FILE *fid=fopen("logs.txt","a+");
     fprintf(fid,"-----------------------------------------------------------------------\n");
     fprintf(fid,"ERROR: el archivo '%s' no se logro crear.\n\n",filename);
     fprintf(fid,"en '%s' , linea = %d,  %s , %s\n\n",__FILE__,__LINE__,__DATE__,__TIME__);
     fclose(fid);
     return;
  }



   fprintf(out,"X=[\n");
   for( i=0;i<N;i++)
     fprintf(out,"%f %f\n",x[i],y[i]);
  fprintf(out,"];\n");
  fprintf(out,"plot(X(:,1),X(:,2),'b.');\n");
  fclose(out);

//Guardo en formato Matlab los nodos frontera
 if((N-Ni)>0){
   out = fopen(filename,"a+");

  if(out==NULL){
   //Actualizo el log de errores
     FILE *fid=fopen("logs.txt","a+");
     fprintf(fid,"-----------------------------------------------------------------------\n");
     fprintf(fid,"ERROR: el archivo '%s' no se logro abrir.\n\n",filename);
     fprintf(fid,"en '%s' , linea = %d,  %s , %s\n\n",__FILE__,__LINE__,__DATE__,__TIME__);
     fclose(fid);
     return;
  }
   fprintf(out,"X=[\n");
   for(i=Ni;i<N;i++)
     fprintf(out,"%f %f\n",x[i],y[i]);
  fprintf(out,"];\n");
  fprintf(out,"hold on\n");
  fprintf(out,"plot(X(:,1),X(:,2),'r*');\n");
  fprintf(out,"hold off\n");
  fclose(out);
 }


//Guardo en formato GNU-Plot
  sprintf(filename,"%s/data",cfg.path);
  out = fopen(filename,"w+");
  

  if(out==NULL){
   //Actualizo el log de errores
     FILE *fid=fopen("logs.txt","a+");
     fprintf(fid,"-----------------------------------------------------------------------\n");
     fprintf(fid,"ERROR: el archivo '%s' no se logro abrir.\n\n",filename);
     fprintf(fid,"en '%s' , linea = %d,  %s , %s\n\n",__FILE__,__LINE__,__DATE__,__TIME__);
     fclose(fid);
     return;
  }




   for(i=0;i<N;i++)
     fprintf(out,"%f %f\n",x[i],y[i]);
  fclose(out);
}
//-------------------------------------------------------------------
void  save_sol(double *x, double *y, double *sol, int N, double mu)
{
  int   i;
  FILE *out;
  char  filename[256];
//Guardo en formato de Matlab    numerical

   sprintf(filename,"%s/datos.m",cfg.path);
   out = fopen(filename,"w+");

  if(out==NULL){
   //Actualizo el log de errores
     FILE *fid=fopen("logs.txt","a+");
     fprintf(fid,"-----------------------------------------------------------------------\n");
     fprintf(fid,"ERROR: el archivo '%s' no se logro abrir.\n\n",filename);
     fprintf(fid,"en '%s' , linea = %d,  %s , %s\n\n",__FILE__,__LINE__,__DATE__,__TIME__);
     fclose(fid);
     return;
  }


   fprintf(out,"X=[\n");
   for(i=0;i<N;i++)
     fprintf(out,"%f %f %f\n",x[i],y[i],sol[i]);
  fprintf(out,"];\n");
  fprintf(out,"x=X(:,1);\n");
  fprintf(out,"y=X(:,2);\n");
  fprintf(out,"z=X(:,3);\n");
  fprintf(out,"plot3(x,y,z,'.');\n");
  fclose(out);

//Guardo en formato de Matlab    real-numerical
   sprintf(filename,"%s/realnum.m",cfg.path);
   out = fopen(filename,"w+");

  if(out==NULL){
   //Actualizo el log de errores
     FILE *fid=fopen("logs.txt","a+");
     fprintf(fid,"-----------------------------------------------------------------------\n");
     fprintf(fid,"ERROR: el archivo '%s' no se logro abrir.\n\n",filename);
     fprintf(fid,"en '%s' , linea = %d,  %s , %s\n\n",__FILE__,__LINE__,__DATE__,__TIME__);
     fclose(fid);
     return;
  }


   fprintf(out,"X=[\n");
   for(i=0;i<N;i++)
     fprintf(out,"%f %f %f\n",x[i],y[i],u(x[i],y[i],mu)-sol[i]);
  fprintf(out,"];\n");
  fprintf(out,"x=X(:,1);\n");
  fprintf(out,"y=X(:,2);\n");
  fprintf(out,"z=X(:,3);\n");
  fprintf(out,"plot3(x,y,z,'.');\n");
  fclose(out);


//Guardo el formato de GNU-Plot
   sprintf(filename,"%s/datos",cfg.path);
   out = fopen(filename,"w+");

  if(out==NULL){
   //Actualizo el log de errores
     FILE *fid=fopen("logs.txt","a+");
     fprintf(fid,"-----------------------------------------------------------------------\n");
     fprintf(fid,"ERROR: el archivo '%s' no se logro abrir.\n\n",filename);
     fprintf(fid,"en '%s' , linea = %d,  %s , %s\n\n",__FILE__,__LINE__,__DATE__,__TIME__);
     fclose(fid);
     return;
  }


   for(i=0;i<N;i++)
     fprintf(out,"%f %f %f\n",x[i],y[i],sol[i]);
  fclose(out);

//Guardo el formato de GNU-Plot  real-numerica
   sprintf(filename,"%s/real-num",cfg.path);
   out = fopen(filename,"w+");


  if(out==NULL){
   //Actualizo el log de errores
     FILE *fid=fopen("logs.txt","a+");
     fprintf(fid,"-----------------------------------------------------------------------\n");
     fprintf(fid,"ERROR: el archivo '%s' no se logro abrir.\n\n",filename);
     fprintf(fid,"en '%s' , linea = %d,  %s , %s\n\n",__FILE__,__LINE__,__DATE__,__TIME__);
     fclose(fid);
     return;
  }


   for(i=0;i<N;i++)
     fprintf(out,"%f %f %f\n",x[i],y[i],u(x[i],y[i],mu)-sol[i]);
  fclose(out);
}
//-------------------------------------------------------------------


void   save_all_sol(int Party, tree **data, int N,IPs dominio[MAX_SUBDOMAINS])
// Los salvo para plotear con GNU-Plot: load show
// Los salvo para plotear con GNU-Plot: solucion.m
{
 int     i,j,ip;
 double  xc,yc,sol;
 FILE *out;
 char  filename[256];

   sprintf(filename,"%s/showsol",cfg.path);
   out = fopen(filename,"w+");

  if(out==NULL){
   //Actualizo el log de errores
     FILE *fid=fopen("logs.txt","a+");
     fprintf(fid,"-----------------------------------------------------------------------\n");
     fprintf(fid,"ERROR: el archivo '%s' no se logro abrir.\n\n",filename);
     fprintf(fid,"en '%s' , linea = %d,  %s , %s\n\n",__FILE__,__LINE__,__DATE__,__TIME__);
     fclose(fid);
     return;
  }




   fprintf(out,"splot ");
 for(i=0;i<(Party-1);i++)   fprintf(out,"'sol%d', ",i+1);
 fprintf(out,"'sol%d' \n",i+1);
 fclose(out);

 for(i=0;i<Party;i++)
 {

   sprintf(filename,"%s/sol%d",cfg.path,i+1);
   out = fopen(filename,"w+");

  if(out==NULL){
   //Actualizo el log de errores
     FILE *fid=fopen("logs.txt","a+");
     fprintf(fid,"-----------------------------------------------------------------------\n");
     fprintf(fid,"ERROR: el archivo '%s' no se logro abrir.\n\n",filename);
     fprintf(fid,"en '%s' , linea = %d,  %s , %s\n\n",__FILE__,__LINE__,__DATE__,__TIME__);
     fclose(fid);
     return;
  }


     for(j=0;j<dominio[i].n;j++)
     {
       ip  = dominio[i].ips[j];
       xc  = data[ip]->x;
       yc  = data[ip]->y;
       sol = data[ip]->sol;
       fprintf(out,"%f %f %f\n",xc,yc,sol);
     }
   fclose(out);
 }

//Ahora creo el archivo para Matlab
   sprintf(filename,"%s/solucion.m",cfg.path);
   out = fopen(filename,"w+");

  if(out==NULL){
   //Actualizo el log de errores
     FILE *fid=fopen("logs.txt","a+");
     fprintf(fid,"-----------------------------------------------------------------------\n");
     fprintf(fid,"ERROR: el archivo '%s' no se logro abrir.\n\n",filename);
     fprintf(fid,"en '%s' , linea = %d,  %s , %s\n\n",__FILE__,__LINE__,__DATE__,__TIME__);
     fclose(fid);
     return;
  }



   fprintf(out,"X=[\n");
   for( i=0; i<N; i++)
   {
     fprintf(out,"%f %f %f\n",data[i]->x,data[i]->y,data[i]->sol);
   }

   fprintf(out,"];\n");
   fprintf(out,"x=X(:,1); y=X(:,2);, z=X(:,3);\n");
   fprintf(out,"plot3(x,y,z,'b.');\n");

 fclose(out);
}
//------------------------------------------------------------------
void   save_all_diff(int Party, tree **data, int N, IPs dominio[MAX_SUBDOMAINS])
// Los salvo para plotear con GNU-Plot: load showdiff
// Los salvo para plotear con Matlab:   realnum
{
 int     i,j,ip;
 double  xc,yc,sol;
 FILE *out;
 char  filename[256];

 sprintf(filename,"%s/showdiff",cfg.path);
 out = fopen(filename,"w+");

  if(out==NULL){
   //Actualizo el log de errores
     FILE *fid=fopen("logs.txt","a+");
     fprintf(fid,"-----------------------------------------------------------------------\n");
     fprintf(fid,"ERROR: el archivo '%s' no se logro abrir.\n\n",filename);
     fprintf(fid,"en '%s' , linea = %d,  %s , %s\n\n",__FILE__,__LINE__,__DATE__,__TIME__);
     fclose(fid);
     return;
  }


   fprintf(out,"splot ");
 for(i=0;i<(Party-1);i++)   fprintf(out,"'diff%d', ",i+1);
 fprintf(out,"'diff%d' \n",i+1);
 fclose(out);

 for(i=0;i<Party;i++)
 {
   sprintf(filename,"%s/diff%d",cfg.path,i+1);
   out = fopen(filename,"w+");

  if(out==NULL){
   //Actualizo el log de errores
     FILE *fid=fopen("logs.txt","a+");
     fprintf(fid,"-----------------------------------------------------------------------\n");
     fprintf(fid,"ERROR: el archivo '%s' no se logro abrir.\n\n",filename);
     fprintf(fid,"en '%s' , linea = %d,  %s , %s\n\n",__FILE__,__LINE__,__DATE__,__TIME__);
     fclose(fid);
     return;
  }


     for(j=0;j<dominio[i].n;j++)
     {
       ip  = dominio[i].ips[j];
       xc  = data[ip]->x;
       yc  = data[ip]->y;
       sol = data[ip]->sol;
       fprintf(out,"%f %f %f\n",xc,yc,u(xc,yc,1)-sol);
     }
   fclose(out);
 }


//Ahora creo el archivo para Matlab
   sprintf(filename,"%s/realnum.m",cfg.path);
   out = fopen(filename,"w+");

  if(out==NULL){
   //Actualizo el log de errores
     FILE *fid=fopen("logs.txt","a+");
     fprintf(fid,"-----------------------------------------------------------------------\n");
     fprintf(fid,"ERROR: el archivo '%s' no se logro abrir.\n\n",filename);
     fprintf(fid,"en '%s' , linea = %d,  %s , %s\n\n",__FILE__,__LINE__,__DATE__,__TIME__);
     fclose(fid);
     return;
  }



   fprintf(out,"X=[\n");
   for( i=0; i<N; i++)
   {
     fprintf(out,"%f %f %f\n",data[i]->x,data[i]->y,u(data[i]->x,data[i]->y,1)-data[i]->sol);
   }

   fprintf(out,"];\n");
   fprintf(out,"x=X(:,1); y=X(:,2);, z=X(:,3);\n");
   fprintf(out,"plot3(x,y,z,'b.');\n");

 fclose(out);

}
