#include <math.h>
#include "jag_mem.h"
#include <stdio.h>

//-------------------------------------------------------------------------

double dot(double *x,double *y, int n)
{
  double s;
  register  int  i;
  double *xptr,*yptr;
  s=0.0;

  xptr=x;  yptr=y;

  for( i=0;i<n;i++)
       s+=(*xptr++)*(*yptr++);
    
  return s;
}


//-------------------------------------------------------------------------

void copy(double *x, int n,double *z)
{
  register int i;
  double *zptr,*xptr;

  zptr=z; xptr=x;

  for(i=0;i<n;i++)
      (*zptr++) = (*xptr++);
}


//-------------------------------------------------------------------------

double maximo(double *x, int n)
{
  register int i;
  double max=x[0];
  double *xptr;
  
  xptr = x;

  for(i=1;i<n;i++)
  {
    if((*xptr)>max)
      max = *xptr;
      
    xptr++;  
  }
 return max;  
}


//-------------------------------------------------------------------------

double minimo(double *x, int n)
{
  register int i;
  double minimo=x[0];
  double *xptr;
  
  xptr = x;  
  

  for(i=1;i<n;i++)
  {
    if( (*xptr)<minimo)
      minimo = *xptr;
      
    xptr++;  
  }
  
  return minimo;
}


//-------------------------------------------------------------------------

double calc_erms(double *x, double *y, int n)
{
 register int i;
 double       s;

 s=0.0;
 for(i=0;i<n;i++)
   s += (x[i]-y[i])*(x[i]-y[i]);

 return sqrt(s/double(n));
}

//-------------------------------------------------------------------------

double calc_einf(double *x, double *y, int n)
{
 register int i;
 double       maxi,tmp;

 maxi = fabs(x[0]-y[0]);

 for(i=1;i<n;i++)
 {
   tmp = fabs(x[i] - y[i]);
   if(tmp>maxi)
        maxi=tmp;
 }

 return maxi;
}

//-------------------------------------------------------------------------

double promedio(double *x, int n)
{
 register int i;
 double       s;

 s=0.0;
 for(i=0;i<n;i++)
   s=s + x[i];

 return s/double(n);
}
//-------------------------------------------------------------------------
void fill(double *x,int n, double val)
{
 register int i;	
 double   *xptr=x; 
 
  for(i=0;i<n;i++)
     (*xptr++) = val; 
  
}
//-------------------------------------------------------------------------
void add_vector(double *x,double *y, int n, double *z)
{
  for(int i=0;i<n;i++)  z[i] = x[i]+y[i];
}
