//----------------------------------------------------------------
#ifndef _QSORT_CPP_
#define _QSORT_CPP_

template <class T>
inline void swap(T a, T b);

template <class T>
void quickSort(T  *a, int lo0, int hi0 );

template <class T>
void quickSort(T *a, T *b, int lo0, int hi0);


template <class T1, class T2, class T3>
void quickSort(T1 *a, T2 *b, T3 *c, int lo0, int hi0);

template <class T>
void quickSort(T *a, T *b, T *c, T *d, int lo0, int hi0);

template <class T1,class T2,class T3,class T4>
void quickSort(T1 *a, T2 *b, T3 *c, T4 *d, int lo0, int hi0);

//----------------------------------------------------------------

template <class T>
void quickSort(T  *a, int lo0, int hi0)
{

    int lo = lo0;
    int hi = hi0;
    T    tmp;

    if (lo >= hi)
       return;
    else
      if (lo == hi - 1)
      {
        if (a[lo] > a[hi])
        {
           tmp   = a[lo];
           a[lo] = a[hi];
           a[hi] = tmp;
        }
         return;
      }

    T pivot = a[(lo + hi) / 2];
    a[(lo + hi) / 2] = a[hi];
    a[hi] = pivot;
    while (lo < hi)
    {
       while (a[lo] <= pivot && lo < hi)
          lo++;

       while (pivot <= a[hi] && lo < hi)
           hi--;

     if (lo < hi)
     {
       tmp   = a[lo];
       a[lo] = a[hi];
       a[hi] = tmp;
      }

    } // while

    a[hi0] = a[hi];
    a[hi] = pivot;

    quickSort (a, lo0, lo - 1);
    quickSort (a, hi + 1, hi0);
}

//--------------------------------------------------------------------------


template <class T>
void quickSort(T *a, T *b, int lo0, int hi0)
// a : es el arreglo a ordenar
// b : es la segunda coordenada para intercambio
{

    int lo = lo0;
    int hi = hi0;
    T   tmp;

    if (lo >= hi)
       return;
    else
      if (lo == hi - 1)
      {
        if (a[lo] > a[hi])
        {
           tmp   = a[lo];
           a[lo] = a[hi];
           a[hi] = tmp;


           tmp   = b[lo];
           b[lo] = b[hi];
           b[hi] = tmp;
        }
         return;
      }

    T pivot = a[(lo + hi) / 2];
    a[(lo + hi) / 2] = a[hi];
    a[hi] = pivot;


    T pivot2 = b[(lo + hi) / 2];
    b[(lo + hi) / 2] = b[hi];
    b[hi] = pivot2;


    while (lo < hi)
    {

       while (a[lo] <= pivot && lo < hi)
          lo++;

       while (pivot <= a[hi] && lo < hi)
           hi--;

     if (lo < hi)
     {
       tmp   = a[lo];
       a[lo] = a[hi];
       a[hi] = tmp;

       tmp   = b[lo];
       b[lo] = b[hi];
       b[hi] = tmp;
      }

    } // while

    a[hi0] = a[hi];
    a[hi] = pivot;

   // Me falta completar esto...jeje

    b[hi0] = b[hi];
    b[hi] = pivot2;

    quickSort(a,b, lo0, lo - 1);
    quickSort(a,b, hi + 1, hi0);
}


//------------------------------------------------------------------------

template <class T1,class T2, class T3>
void quickSort(T1 *a, T2 *b, T3 *c, int lo0, int hi0)
{
  int lo = lo0;
  int hi = hi0;
  T1   tmp1;
  T2   tmp2;
  T3   tmp3;

    if (lo >= hi)
       return;
    else
      if (lo == hi - 1)
      {
        if (a[lo] > a[hi])
        {
           tmp1   = a[lo];
           a[lo] = a[hi];
           a[hi] = tmp1;


           tmp2   = b[lo];
           b[lo] = b[hi];
           b[hi] = tmp2;

           tmp3   = c[lo];
           c[lo] = c[hi];
           c[hi] = tmp3;
        }
         return;
      }

    T1 pivot1 = a[(lo + hi) / 2];
    a[(lo + hi) / 2] = a[hi];
    a[hi] = pivot1;


    T2 pivot2 = b[(lo + hi) / 2];
    b[(lo + hi) / 2] = b[hi];
    b[hi] = pivot2;


    T3 pivot3 = c[(lo + hi) / 2];
    c[(lo + hi) / 2] = c[hi];
    c[hi] = pivot3;


    while (lo < hi)
    {
       while (a[lo] <= pivot1 && lo < hi)
          lo++;

       while (pivot1 <= a[hi] && lo < hi)
           hi--;

     if (lo < hi)
     {
       tmp1   = a[lo];
       a[lo] = a[hi];
       a[hi] = tmp1;

       tmp2   = b[lo];
       b[lo] = b[hi];
       b[hi] = tmp2;

       tmp3   = c[lo];
       c[lo] = c[hi];
       c[hi] = tmp3;
      }

    } // while

    a[hi0] = a[hi];
    a[hi] = pivot1;

   // Me falta completar esto...jeje

    b[hi0] = b[hi];
    b[hi] = pivot2;

    c[hi0] = c[hi];
    c[hi] = pivot3;

    quickSort(a,b,c, lo0, lo - 1);
    quickSort(a,b,c, hi + 1, hi0);

}

//--------------------------------------------------------------------------
//------------------------------------------------------------------------

template <class T>
void quickSort(T *a, T *b, T *c, T *d, int lo0, int hi0)
// a : es el arreglo a ordenar
// b : es la segunda coordenada para intercambio
{

   int lo = lo0;
    int hi = hi0;
    T   tmp;

    if (lo >= hi)
       return;
    else
      if (lo == hi - 1)
      {
        if (a[lo] > a[hi])
        {
           tmp   = a[lo];
           a[lo] = a[hi];
           a[hi] = tmp;


           tmp   = b[lo];
           b[lo] = b[hi];
           b[hi] = tmp;

           tmp   = c[lo];
           c[lo] = c[hi];
           c[hi] = tmp;
	   
           tmp   = d[lo];
           d[lo] = d[hi];
           d[hi] = tmp;
	   	   
        }
         return;
      }

    T pivot = a[(lo + hi) / 2];
    a[(lo + hi) / 2] = a[hi];
    a[hi] = pivot;


    T pivot2 = b[(lo + hi) / 2];
    b[(lo + hi) / 2] = b[hi];
    b[hi] = pivot2;


    T pivot3 = c[(lo + hi) / 2];
    c[(lo + hi) / 2] = c[hi];
    c[hi] = pivot3;
    
    
    T pivot4 = d[(lo + hi) / 2];
    d[(lo + hi) / 2] = d[hi];
    d[hi] = pivot4;    


    while (lo < hi)
    {
       while (a[lo] <= pivot && lo < hi)
          lo++;

       while (pivot <= a[hi] && lo < hi)
           hi--;

     if (lo < hi)
     {
       tmp   = a[lo];
       a[lo] = a[hi];
       a[hi] = tmp;

       tmp   = b[lo];
       b[lo] = b[hi];
       b[hi] = tmp;

       tmp   = c[lo];
       c[lo] = c[hi];
       c[hi] = tmp;
       
       
       tmp   = d[lo];
       d[lo] = d[hi];
       d[hi] = tmp;       
      }

    } // while

    a[hi0] = a[hi];
    a[hi] = pivot;

   // Me falta completar esto...jeje

    b[hi0] = b[hi];
    b[hi] = pivot2;

    c[hi0] = c[hi];
    c[hi] = pivot3;
    
    d[hi0] = d[hi];
    d[hi] = pivot4;    

    quickSort(a,b,c,d, lo0, lo - 1);
    quickSort(a,b,c,d, hi + 1, hi0);

}


//--------------------------------------------------------------------------
//------------------------------------------------------------------------
template <class T1,class T2,class T3,class T4>
void quickSort(T1 *a, T2 *b, T3 *c, T4 *d, int lo0, int hi0)
// a : es el arreglo a ordenar
// b : es la segunda coordenada para intercambio
{

    int lo = lo0;
    int hi = hi0;
    T1   tmp1;
    T2   tmp2;
    T3   tmp3;
    T4   tmp4;            

    if (lo >= hi)
       return;
    else
      if (lo == hi - 1)
      {
        if (a[lo] > a[hi])
        {
           tmp1   = a[lo];
           a[lo] = a[hi];
           a[hi] = tmp1;


           tmp2   = b[lo];
           b[lo] = b[hi];
           b[hi] = tmp2;

           tmp3   = c[lo];
           c[lo] = c[hi];
           c[hi] = tmp3;
	   
           tmp4   = d[lo];
           d[lo] = d[hi];
           d[hi] = tmp4;
	   	   
        }
         return;
      }

    T1 pivot1 = a[(lo + hi) / 2];
    a[(lo + hi) / 2] = a[hi];
    a[hi] = pivot1;


    T2 pivot2 = b[(lo + hi) / 2];
    b[(lo + hi) / 2] = b[hi];
    b[hi] = pivot2;


    T3 pivot3 = c[(lo + hi) / 2];
    c[(lo + hi) / 2] = c[hi];
    c[hi] = pivot3;
    
    
    T4 pivot4 = d[(lo + hi) / 2];
    d[(lo + hi) / 2] = d[hi];
    d[hi] = pivot4;    


    while (lo < hi)
    {
       while (a[lo] <= pivot1 && lo < hi)
          lo++;

       while (pivot1 <= a[hi] && lo < hi)
           hi--;

     if (lo < hi)
     {
       tmp1   = a[lo];
       a[lo] = a[hi];
       a[hi] = tmp1;

       tmp2   = b[lo];
       b[lo] = b[hi];
       b[hi] = tmp2;

       tmp3   = c[lo];
       c[lo] = c[hi];
       c[hi] = tmp3;
       
       
       tmp4   = d[lo];
       d[lo] = d[hi];
       d[hi] = tmp4;       
      }

    } // while

    a[hi0] = a[hi];
    a[hi] = pivot1;

   // Me falta completar esto...jeje

    b[hi0] = b[hi];
    b[hi] = pivot2;

    c[hi0] = c[hi];
    c[hi] = pivot3;
    
    d[hi0] = d[hi];
    d[hi] = pivot4;    

    quickSort(a,b,c,d, lo0, lo - 1);
    quickSort(a,b,c,d, hi + 1, hi0);

}

#endif
