
//-------------------------------------------------------------------
void get_error_localIF(tree **data, int N, double &maxi)
// Determino el error de interpolacion local de los nodos interiores y de frontera..es decir, de todos...jeje
{
  register int     i,j;
  int     K=0;
  tree    *seleccionado;
  tree    *Vecinos[128]; 
  double  X[128],Y[128],F[128];
  double  xc,yc,fc;
  double  val;

//Limpio los errores de interpolacion local
 for(i=0;i<N;i++)
 {
   data[i]->error = 0.0;
 }

//Interpolo al estilo de Iskee
 for(i=0;i<N;i++)
 {
  //Aqui debo de buscar a sus vecinos mas cercanos para calcular el error
  //de interpolacion local
     seleccionado = data[i];
     if(seleccionado==NULL){
       printf("ERROR-2: el nodo %d no se encontro en archivo = '%s' , linea = %d.\n",i,__FILE__,__LINE__);
     }
   else{

        K=0;
        xc = seleccionado->x;
        yc = seleccionado->y;
        fc = seleccionado->sol;

      //Selecciono los K-vecinos
        get_kvecinos2(seleccionado,Vecinos,K);

       if(K<=2){
            printf("Esta raro:  K = %d en (%f,%f)\n",K,xc,yc);
           exit(1);
      }

        for( j=0; j<K; j++)
        {
           X[j]=Vecinos[j]->x;
           Y[j]=Vecinos[j]->y;
           F[j]=Vecinos[j]->sol;
        }
          double aux;
          val = interpola_tps2d_P1(xc,yc,X,Y,F,K);  // Phi + 1 + x + y
          val = fabs(fc-val);
          seleccionado->error = val;
   }

 }

//Determino el error maximo de interpolacion local
  maxi=0;
 for(i=0;i<N;i++)
 {
  if(data[i]->error>maxi)  maxi = data[i]->error;
 }
 //printf("Error local maximo = %f.\n",maxi);
}




//-------------------------------------------------------------------
int isin(tree *nodo, tree **nodos, int N)
{
 if(N<=0) return 0;

 for(int i=0;i<N;i++)
 {
   if(nodo==nodos[i])
   {
     return 1;
   }
 }
 return 0;
}


//-------------------------------------------------------------------
void   refinaIF(tree *raiz,tree **data, int N, int min_nivel_ref,int max_nivel_ref,
                 double thetar, double thetac,int &ref, int &rem)
{
 tree **papa_refinados;
 tree  *seleccionado;
 int    cont=0;
 register  int    i;
 ref = 0; rem = 0;
 papa_refinados = (tree **)malloc(5*N*sizeof(tree));


//Cuento cuantos nodos van a pasar el refinamiento local
 for(i=0;i<N;i++)
 {
   if(data[i]->error>=thetar)
   {
      ref=ref+1;
   }
   if(data[i]->error<thetac)
   {
      rem=rem+1;
   }
 }// for i

 printf("Posibles candidatos a refinar = %d de %d\n",ref,N);
 printf("Posibles candidatos a remover = %d de %d\n",rem,N);


 int candidatos;
 candidatos = ref;



 ref=0;
//Refino los nodos
//for(int iter=0;iter<3;iter++)
 for(i=0;i<N;i++)
 {
   seleccionado = data[i];
   if(seleccionado->error>=thetar)
   {
     if(refina(seleccionado,max_nivel_ref)==1)
     {
        ref=ref+1;
        papa_refinados[cont++] = seleccionado->papa;
     }
   }
 }// for i


 rem=0;

//Remuevo los nodos
 for(i=0;i<N;i++)
 {
   seleccionado = data[i];
   if(seleccionado->error<=thetac)
    if(isin(seleccionado->papa,papa_refinados,cont)==0)
      if(remueve2(seleccionado,min_nivel_ref)==1)
      {
         rem=rem+1;
         papa_refinados[cont++] = seleccionado->papa;
      }
 }// for i


 free(papa_refinados);
}

//-------------------------------------------------------------------
void restriccion_suavidad2(tree *raiz, int &restriccion, int max_nivel_ref)
//Checo la restriccion de suavidad 2:1
{
   tree *Vecinos[128];
   double *x, *y;
   tree   **data;
   int   K,COTA;
   int   Ni,N=0;

   cont_hojas(raiz,N);

   x=new double[N]; y=new double[N];
   data = (tree **)malloc(N*sizeof(tree));

   Ni=0;  get_datos_interior(raiz,x,y,data,Ni);
   N=Ni;  get_datos_frontera(raiz,x,y,data,N);

   delete[] x; delete[] y;

   restriccion=0;
for(int i=0;i<N;i++)
{
  tree *select;

  select = data[i];

  K=0;
  get_kvecinos2(select,Vecinos,K);

  for(int j=0;j<K;j++)
  {
      if(fabs(double(select->nivel)-double(Vecinos[j]->nivel))>1.0)
      {
        if(select->nivel>Vecinos[j]->nivel){
           if(refina(Vecinos[j],max_nivel_ref)==1)
             restriccion++;
        }
        else{
           if(refina(select,max_nivel_ref)==1)
             restriccion++;
         }
      }
   }      // if der
}
 free(data);
}

